/*
   $Source: /home/yee/C/RCS/byte.h,v $
   $Author: yee $
   $Date: 1999/02/10 16:39:47 $
   $Revision: 1.17 $

   This file contains byte operations.

   Parameters : none

   Assumptions : none known

   Bugs : none known

   To Do:
   1) figure out an elegant way not to use MASK1

   $Log: byte.h,v $
   Revision 1.17  1999/02/10 16:39:47  yee
   *** empty log message ***

   Revision 1.16  1999/01/09 16:23:22  yee
   *** empty log message ***

   Revision 1.15  1999/01/08 03:51:14  yee
   eliminated (effectively) extra macro BCOPY().

   Revision 1.14  1998/08/22 15:37:39  yee
   all geometries work!

  Copyright 1997 by Conway Yee.  All rights reserved.
 */

/*****************************************************************************/
/*****************************************************************************/

#ifndef BYTE_H
#define BYTE_H
                                     /* swap c bytes between a and b */
#define BSWAP(a,b,c) {           \
           char tmp;             \
           int tc=(c);           \
           char *ta=(char *)(a); \
           char *tb=(char *)(b); \
           while(tc--) {         \
             tmp = *ta;          \
             *ta++ = *tb;        \
             *tb++ = tmp;        \
           }                     \
        }

#define MASK1 ((unsigned int)1)              /* reverse n bits of i into j */
#define FLIP(n,i,j) {                                         \
          int idum = i;   /* dummy integer for unslid bits */ \
          int bit_ct = n; /* counter */                       \
                                                              \
          for(j=0;bit_ct;idum>>=1,bit_ct--) {                 \
            j <<= 1;                                          \
            if(MASK1&idum) j |= MASK1;                        \
          }                                                   \
        }
#undef MASK1

#endif BYTE_H
